#include "Chars.h"
#include "Vram.h"
#include "VVram.h"
#include "Sprite.h"

constexpr byte InvalidCode = 0xff;

struct Sprite {
    byte x, y;
    byte code;
};

Sprite[SpriteCount] Sprites;

void InitSprites()
{
    HideAllSprites();
}

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->code = InvalidCode;
    }
}


void ShowSprite(byte index, byte x, byte y, byte code)
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->x = x;
    p->y = y;
    p->code = code;
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->code = InvalidCode;
}


void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->code != InvalidCode) {
            ptr<byte> pFront;
            byte y, c;
            y = p->y;
            pFront = VVramPtr(p->x, y);
            c = p->code;
            pFront[0] = c; 
            if (p->code >= Char_Enemy) {
                ++c; pFront[1] = c;
                if (y < VVramHeight - 1) {
                    ++c; pFront[VVramWidth] = c;
                    ++c; pFront[VVramWidth + 1] = c;
                }
            }
        }
    }
}
