include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext Status_

dseg
VVram_: public VVram_
    defs VVramWidth*VVramHeight
RowFlags_: public RowFlags_
    defs 4
SpSave:
    defw 0


; void ClearVVram();
cseg
ClearVVram_: public ClearVVram_
    push af | push hl | push de | push bc
        ld (SpSave),sp
        ld hl,VVram_+VVramWidth*VVramHeight
        ld de,VVramWidth*VVramHeight/2
        ld bc,(Char_Space shl 8) or Char_Space
        di
            ld sp,hl
            do
                push bc
                dec de
                ld a,e
                or d
            while nz | wend
            ld hl,(SpSave)
            ld sp,hl
        ei
    pop bc | pop de | pop hl | pop af
ret


; ptr<byte> VVramPtr(byte x, byte y);
cseg
VVramPtr_: public VVramPtr_
    push de
        ex af,af'
            ld a,e
            add a,a ;*2
            add a,a ;*4
            add a,a ;*8
            sub e ;*7
            ld e,a
        ex af,af'
        ex de,hl
            ld h,0
            add hl,hl ;*14
            add hl,hl ;*28
        ex de,hl
        ld l,a
        ld h,0
        add hl,de
        ld de,VVram_
        add hl,de
    pop de
ret


; void SetRowFlags(byte y, byte b);
cseg
SetRowFlags_: public SetRowFlags_
    push af | push hl | push de | push bc
        ld d,0
        ld c,a
        and 7
        if nz
            ex de,hl
                ld b,a
                do
                    add hl,hl
                dwnz
            ex de,hl
        endif
        ld a,c
        rrca | rrca | rrca | and 3
        ld c,a
        ld b,0
        ld hl,RowFlags_
        add hl,bc
        ld a,(hl)
        or e
        ld (hl),a
        inc hl
        ld a,(hl)
        or d
        ld (hl),a
    pop bc | pop de | pop hl | pop af
ret


; void StatusToVVram();
cseg
StatusToVVram_: public StatusToVVram_
    push af | push hl | push de | push bc
        ld hl,Status_
        ld de,VVram_
        ld c,2
        do
            ld b,VVramWidth
            do
                ld a,(hl) | inc hl
                cp Char_Space
                if nz
                    ld (de),a
                endif
                inc de
            dwnz
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret
