include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext VVram_, RowFlags_
ext Status_


; void InitVram();
cseg
InitVram_: public InitVram_
    call ClearScreen_
    ; call ShowVram_
ret


Clear:
    do
        ld (hl),Char_Space
        inc hl
        dec bc
        ld a,c
        or b
    while nz | wend
ret

; void ClearScreen();
ClearScreen_: public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram
        ld bc,VramWidth*VramHeight
        call Clear

        ld hl,Status_
        ld bc,VVramWidth*2
        call Clear
    pop bc | pop hl | pop af
ret


; ptr<byte> PrintC(ptr<byte> address, byte c);
cseg
CharTable:
    defb "-0123456789ABCEFGHIMNOPRSTUV"
PrintC_: public PrintC_
    push af | push bc
        cp ' '
        if nz
            push hl
                ld bc,28*256+2
                ld hl,CharTable
                ld a,e
                do
                    cp (hl)
                    jr z,PrintC_break
                    inc hl
                    inc c
                dwnz
                PrintC_break:
                ld a,c
            pop hl
        else
            ld a,Char_Space
        endif
        ld (hl),a
        inc hl
    pop bc | pop af
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc
        ld hl,VVram_
        ld de,Vram+(VramWidth-VVramWidth)/2
        ld c,VVramHeight
        do
            ld b,VVramWidth
            do
                ld a,(hl) | inc hl
                ld (de),a | inc de
            dwnz
            inc de | inc de
            inc de | inc de
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void StatusToVram();
cseg
StatusToVram_: public StatusToVram_
    push af | push hl | push de | push bc
        ld hl,Status_
        ld de,Vram+(VramWidth-VVramWidth)/2
        ld c,2
        do
            ld b,VVramWidth
            do
                ld a,(hl) | inc hl
                cp Char_Space
                if nz
                    ld (de),a
                endif
                inc de
            dwnz
            inc de | inc de
            inc de | inc de
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret
